# x509ce.cnf
# X509CE conformation file

#.IMPORT ../x509if/x509if-exp.cnf
#.IMPORT ../x509af/x509af-exp.cnf
#.IMPORT ../x509sat/x509sat-exp.cnf
#.IMPORT ../p1/p1-exp.cnf

# Forward declaration
#.CLASS CERT-POLICY-QUALIFIER
&id         ObjectIdentifierType
&Qualifier
#.END

# InformationFramework classes
# #.CLASS ATTRIBUTE
#&derivation            ClassReference ATTRIBUTE
#&Type
#&equality-match        ClassReference MATCHING-RULE
#&ordering-match        ClassReference MATCHING-RULE
#&substrings-match      ClassReference MATCHING-RULE
#&single-valued         BooleanType
#&collective            BooleanType
#&no-user-modification  BooleanType
#&usage
#&id                    ObjectIdentifierType
# #.END

#.CLASS MATCHING-RULE
&ParentMatchingRules   ClassReference MATCHING-RULE
&AssertionType
&uniqueMatchIndicator  ClassReference ATTRIBUTE
&id                    ObjectIdentifierType
#.END
#.EXPORTS
AltNameType
AttributesSyntax
AuthorityKeyIdentifier
BaseCRLNumber
BaseDistance
BaseRevocationInfo
BasicConstraintsSyntax
CertificateAssertion
CertificateExactAssertion
CertificateListAssertion
CertificateListExactAssertion
CertificatePairAssertion
CertificatePairExactAssertion
CertificatePoliciesSyntax
CertPolicySet
CRLDistPointsSyntax
CRLNumber
CRLReason
CRLReferral
CRLScopeSyntax
CRLStreamIdentifier
DeltaInformation
DeltaRefInfo
DistributionPoint
DistributionPointName
EDIPartyName
GeneralName
GeneralNames
GeneralSubtree
GeneralSubtrees
HoldInstruction
IssuingDistPointSyntax
KeyIdentifier
KeyPurposeId
KeyPurposeIDs
KeyUsage
NameConstraintsSyntax
NumberRange
OnlyCertificateTypes
OrderedListSyntax
PerAuthorityScope
PkiPathMatchSyntax
PolicyConstraintsSyntax
PolicyInformation
PolicyMappingsSyntax
PolicyQualifierInfo
PrivateKeyUsagePeriod
ReasonFlags
SkipCerts
StatusReferral
StatusReferrals
SubjectKeyIdentifier
ScramblerCapabilities
CiplusInfo
CicamBrandId
SecurityLevel

#.PDU
ScramblerCapabilities
CiplusInfo
CicamBrandId
SecurityLevel


#.REGISTER
CertificatePoliciesSyntax B "2.5.29.3"  "id-ce-certificatePolicies"
AttributesSyntax          B "2.5.29.9"  "id-ce-subjectDirectoryAttributes"
SubjectKeyIdentifier      B "2.5.29.14" "id-ce-subjectKeyIdentifier"
KeyUsage                  B "2.5.29.15" "id-ce-keyUsage"
PrivateKeyUsagePeriod     B "2.5.29.16" "id-ce-privateKeyUsagePeriod"
GeneralNames              B "2.5.29.17" "id-ce-subjectAltName"
GeneralNames              B "2.5.29.18" "id-ce-issuerAltName"
BasicConstraintsSyntax    B "2.5.29.19" "id-ce-basicConstraints"
CRLNumber                 B "2.5.29.20" "id-ce-cRLNumber"
CRLReason                 B "2.5.29.21" "id-ce-reasonCode"
HoldInstruction           B "2.5.29.23" "id-ce-instructionCode"
BaseCRLNumber             B "2.5.29.27" "id-ce-deltaCRLIndicator"
IssuingDistPointSyntax    B "2.5.29.28" "id-ce-issuingDistributionPoint"
GeneralNames              B "2.5.29.29" "id-ce-certificateIssuer"
NameConstraintsSyntax     B "2.5.29.30" "id-ce-nameConstraints"
CRLDistPointsSyntax       B "2.5.29.31" "id-ce-cRLDistributionPoints"
CertificatePoliciesSyntax B "2.5.29.32" "id-ce-certificatePolicies"
PolicyMappingsSyntax      B "2.5.29.33" "id-ce-policyMappings"
AuthorityKeyIdentifier    B "2.5.29.35" "id-ce-authorityKeyIdentifier"
PolicyConstraintsSyntax   B "2.5.29.36" "id-ce-policyConstraints"
KeyPurposeIDs             B "2.5.29.37" "id-ce-extKeyUsage"
CRLStreamIdentifier       B "2.5.29.40" "id-ce-cRLStreamIdentifier"
CRLScopeSyntax            B "2.5.29.44" "id-ce-cRLScope"
StatusReferrals           B "2.5.29.45" "id-ce-statusReferrals"
CRLDistPointsSyntax       B "2.5.29.46" "id-ce-freshestCRL"
OrderedListSyntax         B "2.5.29.47" "id-ce-orderedList"
DeltaInformation          B "2.5.29.53" "id-ce-deltaInfo"
SkipCerts                 B "2.5.29.54" "id-ce-inhibitAnyPolicy"
ToBeRevokedSyntax         B "2.5.29.58" "id-ce-toBeRevoked"
RevokedGroupsSyntax       B "2.5.29.59" "id-ce-RevokedGroups"
ExpiredCertsOnCRL         B "2.5.29.60" "id-ce-expiredCertsOnCRL"
AAIssuingDistPointSyntax  B "2.5.29.61" "id-ce-aAissuingDistributionPoint"
NFTypes                   B "1.3.6.1.5.5.7.1.34" "id-pe-nftype"

CertificateAssertion      B "2.5.13.35" "id-mr-certificateMatch"
CertificatePairExactAssertion B "2.5.13.36" "id-mr-certificatePairExactMatch"
CertificatePairAssertion  B "2.5.13.37" "id-mr-certificatePairMatch"
CertificateListExactAssertion B "2.5.13.38" "id-mr-certificateListExactMatch"
CertificateListAssertion  B "2.5.13.39" "id-mr-certificateListMatch"
PkiPathMatchSyntax        B "2.5.13.62" "id-mr-pkiPathMatch"
EnhancedCertificateAssertion  B "2.5.13.65" "id-mr-enhancedCertificateMatch"

# These are obsolete???
# The following OBJECT IDENTIFIERS are not used by this Specification:
# {id-ce 2}, {id-ce 3}, {id-ce 4}, {id-ce 5}, {id-ce 6}, {id-ce 7},
# {id-ce 8}, {id-ce 10}, {id-ce 11}, {id-ce 12}, {id-ce 13},
# {id-ce 22}, {id-ce 25}, {id-ce 26}

# Microsoft extensions
CertificateTemplate       B "1.3.6.1.4.1.311.21.7"  "id-ms-certificate-template"
CertificatePoliciesSyntax B "1.3.6.1.4.1.311.21.10" "id-ms-application-certificate-policies"
NtdsCaSecurity            B "1.3.6.1.4.1.311.25.2" "id-ms-ntds-ca-security"
NtdsObjectSid             B "1.3.6.1.4.1.311.25.2.1" "id-ms-ntds-object-sid"

# Entrust extensions
EntrustVersionInfo        B "1.2.840.113533.7.65.0" "id-ce-entrustVersionInfo"

#.NO_EMIT

#.TYPE_RENAME

#.TYPE_ATTR
SecurityLevel DISPLAY = BASE_DEC STRINGS = VALS64(ciplus_security_level)

#.FIELD_RENAME
CRLReferral/issuer  crlr_issuer
CertificatePairExactAssertion/issuedToThisCAAssertion   cpea_issuedToThisCAAssertion
CertificatePairExactAssertion/issuedByThisCAAssertion   cpea_issuedByThisCAAssertion
CertificateGroup/serialNumberRange                      certificateGroupNumberRange
CertificateAssertion/subjectAltName                     subjectAltNameType
EnhancedCertificateAssertion/pathToName                 enhancedPathToName

#.FN_PARS PolicyQualifierInfo/policyQualifierId
  FN_VARIANT = _str  HF_INDEX = hf_x509ce_object_identifier_id  VAL_PTR = &actx->external.direct_reference

#.FN_BODY PolicyQualifierInfo/qualifier
  offset=call_ber_oid_callback(actx->external.direct_reference, tvb, offset, actx->pinfo, tree, NULL);

#.FN_BODY GeneralName/iPAddress
  switch (tvb_reported_length(tvb)) {
  case 4: /* IPv4 */
    proto_tree_add_item(tree, hf_x509ce_IPAddress_ipv4, tvb, offset, 4, ENC_BIG_ENDIAN);
    offset += 4;
    break;
  case 16: /* IPv6 */
    proto_tree_add_item(tree, hf_x509ce_IPAddress_ipv6, tvb, offset, 16, ENC_NA);
    offset += 16;
    break;
  }

#.FN_PARS OtherNameType
  FN_VARIANT = _str  VAL_PTR = &actx->external.direct_reference

#.FN_BODY OtherNameValue
  offset=call_ber_oid_callback(actx->external.direct_reference, tvb, offset, actx->pinfo, tree, NULL);

#.FN_FTR GeneralName/uniformResourceIdentifier

  proto_item_set_url(actx->created_item);

#.END

#
# Editor modelines  -  https://www.wireshark.org/tools/modelines.html
#
# Local variables:
# c-basic-offset: 2
# tab-width: 8
# indent-tabs-mode: nil
# End:
#
# vi: set shiftwidth=2 tabstop=8 expandtab:
# :indentSize=2:tabSize=8:noTabs=true:
#
